package com.zksy.web.controller.basicData;


import com.zksy.common.core.controller.BaseController;
import com.zksy.common.core.domain.AjaxResult;
import com.zksy.common.utils.file.ExcelUtils;
import com.zksy.system.basicData.domain.CrmAdministrativeCompulsionInformation;
import com.zksy.system.basicData.service.CrmAdministrativeCompulsionInformationService;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zksy.utils.DowntemplateUtil;
import com.zksy.utils.SearchUtil;
import com.zksy.common.annotation.Log;
import com.zksy.common.enums.BusinessType;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

/**
 * 行政强制信息填报模板Controller
 *
 * @author sy
 * @date 2024-05-08
 */
@RestController
@RequestMapping("/crmAdministrativeCompulsionInformation")
@Api(tags = "行政强制信息填报模板", description = "行政强制信息填报模板desc")
public class CrmAdministrativeCompulsionInformationController extends BaseController {

    @Autowired
    private CrmAdministrativeCompulsionInformationService service;

    @GetMapping("/getById/{borrowId}")
    @ApiOperation(value = "行政强制信息填报模板搜索getById")
    public AjaxResult getById(@PathVariable String borrowId) {
        return AjaxResult.success(service.getById(borrowId));
    }

    @GetMapping("/findByPage")
    @ApiOperation(value = "行政强制信息填报模板分页")
    public Page findByPage(long pageNum, long pageSize, String conditionJson) throws Exception {
        return service.page(new Page<>(pageNum, pageSize), SearchUtil.parseWhereSql(conditionJson));
    }

    @GetMapping("/getList")
    @ApiOperation(value = "行政强制信息填报模板查询所有")
    public AjaxResult getList(String conditionJson) throws Exception {
        return AjaxResult.success(service.list(SearchUtil.parseWhereSql(conditionJson)));
    }

    /**
     * 新增行政强制信息填报模板
     */
    @PostMapping("/save")
    @ApiOperation(value = "行政强制信息填报模板新增")
    @Log(title = "新增行政强制信息填报模板", businessType = BusinessType.INSERT)
    public boolean save(@RequestBody CrmAdministrativeCompulsionInformation crmAdministrativeCompulsionInformation) {
        return service.save(crmAdministrativeCompulsionInformation);
    }

    /**
     * 修改行政强制信息填报模板
     */
    @PostMapping("/updateById")
    @ApiOperation(value = "行政强制信息填报模板修改")
    @Log(title = "修改行政强制信息填报模板", businessType = BusinessType.UPDATE)
    public boolean updateById(@RequestBody CrmAdministrativeCompulsionInformation crmAdministrativeCompulsionInformation) {
        return service.updateById(crmAdministrativeCompulsionInformation);
    }

    /**
     * 导入行政强制信息填报模板
     */
    @ApiOperation("行政强制信息填报模板导入")
    @Log(title = "行政强制信息填报模板", businessType = BusinessType.IMPORT)
    @PostMapping("/importData")
    public AjaxResult importData(MultipartFile file)
    {
        try {
            List<CrmAdministrativeCompulsionInformation> crmAdministrativeCompulsionInformationAll = service.list();
            List<CrmAdministrativeCompulsionInformation> list = ExcelUtils.readMultipartFile(file, CrmAdministrativeCompulsionInformation.class,CrmAdministrativeCompulsionInformation.class.getDeclaredFields().length - 2);
            if(crmAdministrativeCompulsionInformationAll != null && crmAdministrativeCompulsionInformationAll.size() > 0) {
                //return AjaxResult.error("数据已存在，如需重新导入请清空数据");
            }
            if(list.size() > 0){
                service.saveBatch(list);
                return success("导入成功，共计："+list.size()+"条");
            }else{
                return AjaxResult.error("无数据");
            }
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导入数据失败");
        }
    }

    @ApiOperation("行政强制信息填报模板导出")
    @Log(title = "行政强制信息填报模板", businessType = BusinessType.EXPORT)
    @PostMapping("/exportData")
    public AjaxResult exportData(HttpServletResponse response, String conditionJson){
        try {
            List<CrmAdministrativeCompulsionInformation> wrapperList = service.list(SearchUtil.parseWhereSql(conditionJson));
            ExcelUtils.export(response,"行政强制信息填报模板",wrapperList,CrmAdministrativeCompulsionInformation.class);
            return AjaxResult.success("导出数据成功");
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导出数据失败");
        }
    }

    @Log(title = "行政强制信息填报模板", businessType = BusinessType.DELETE)
    @PostMapping("/delete")
    @ApiOperation(value = "删除行政强制信息填报模板", notes = "删除行政强制信息填报模板")
    public AjaxResult delete(@RequestBody List<String> ids)
    {
        return toAjax(service.removeByIds(ids));
    }

    @DeleteMapping("/deleteAll")
    @ApiOperation(value = "清除数据", notes = "清除数据")
    public AjaxResult deleteAll(){
        return service.deleteAll();
    }

    @PostMapping("/getUploadTemplate")
    @ApiOperation(value = "获取上传模板", notes = "获取上传模板")
    public void getUploadTemplate(HttpServletResponse response) throws IOException {
        DowntemplateUtil.downloadTemplate(response,"行政强制信息模板");
    }
}

